from django.views.generic import TemplateView

from src.models import Graph, Vertex, Arc


class IndexView(TemplateView):
    template_name = "index.html"

    def get_context_data(self):
        return {
            "graphs": [Graph.CYCLE, Graph.PATH],
        }


class TypeView(TemplateView):
    template_name = "type.html"

    def get_context_data(self, **kwargs):
        return {
            "kwargs": kwargs,
            "graphs": Graph.objects.filter(
                graph_type=kwargs.get("type")
            ).order_by("binary"),
        }


class InfoView(TemplateView):
    template_name = "info.html"

    def get_context_data(self, **kwargs):
        graph = Graph.objects.get(id=kwargs.get("info"))
        return {
            "arcs": Arc.objects.filter(vertex_in__graph=graph).order_by("id"),
            "vertices": Vertex.objects.filter(graph=graph).order_by("id"),
            "graph": graph,
            "type_name": graph.graph_type,
        }
